Loading...
Searching...
No Matches
trtri: Triangular inverse; used in getri, potri
Dense LA » MAGMA BLAS and Auxiliary » Level 3: matrix-matrix operations, O(n^3) work

\(A = A^{-1}\) where \(A\) is triangular More...

## Functions

magma_int_t | magma_ctrtri (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaFloatComplex *A, magma_int_t lda, magma_int_t *info)
| CTRTRI computes the inverse of a real upper or lower triangular matrix A.
magma_int_t | magma_ctrtri_expert_gpu_work (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaFloatComplex_ptr dA, magma_int_t ldda, magma_int_t *info, void *host_work, magma_int_t *lwork_host, void *device_work, magma_int_t *lwork_device, magma_queue_t queues[2])
| CTRTRI computes the inverse of a real upper or lower triangular matrix dA.
magma_int_t | magma_ctrtri_gpu (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaFloatComplex_ptr dA, magma_int_t ldda, magma_int_t *info)
| CTRTRI computes the inverse of a real upper or lower triangular matrix dA.
magma_int_t | magma_dtrtri (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, double *A, magma_int_t lda, magma_int_t *info)
| DTRTRI computes the inverse of a real upper or lower triangular matrix A.
magma_int_t | magma_dtrtri_expert_gpu_work (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaDouble_ptr dA, magma_int_t ldda, magma_int_t *info, void *host_work, magma_int_t *lwork_host, void *device_work, magma_int_t *lwork_device, magma_queue_t queues[2])
| DTRTRI computes the inverse of a real upper or lower triangular matrix dA.
magma_int_t | magma_dtrtri_gpu (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaDouble_ptr dA, magma_int_t ldda, magma_int_t *info)
| DTRTRI computes the inverse of a real upper or lower triangular matrix dA.
magma_int_t | magma_strtri (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, float *A, magma_int_t lda, magma_int_t *info)
| STRTRI computes the inverse of a real upper or lower triangular matrix A.
magma_int_t | magma_strtri_expert_gpu_work (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaFloat_ptr dA, magma_int_t ldda, magma_int_t *info, void *host_work, magma_int_t *lwork_host, void *device_work, magma_int_t *lwork_device, magma_queue_t queues[2])
| STRTRI computes the inverse of a real upper or lower triangular matrix dA.
magma_int_t | magma_strtri_gpu (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaFloat_ptr dA, magma_int_t ldda, magma_int_t *info)
| STRTRI computes the inverse of a real upper or lower triangular matrix dA.
magma_int_t | magma_ztrtri (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaDoubleComplex *A, magma_int_t lda, magma_int_t *info)
| ZTRTRI computes the inverse of a real upper or lower triangular matrix A.
magma_int_t | magma_ztrtri_expert_gpu_work (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaDoubleComplex_ptr dA, magma_int_t ldda, magma_int_t *info, void *host_work, magma_int_t *lwork_host, void *device_work, magma_int_t *lwork_device, magma_queue_t queues[2])
| ZTRTRI computes the inverse of a real upper or lower triangular matrix dA.
magma_int_t | magma_ztrtri_gpu (magma_uplo_t uplo, magma_diag_t diag, magma_int_t n, magmaDoubleComplex_ptr dA, magma_int_t ldda, magma_int_t *info)
| ZTRTRI computes the inverse of a real upper or lower triangular matrix dA.

## Detailed Description

\(A = A^{-1}\) where \(A\) is triangular

## Function Documentation

## magma_ctrtri()

magma_int_t magma_ctrtri | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magma_int_t * | info )

CTRTRI computes the inverse of a real upper or lower triangular matrix A.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  A

  COMPLEX array, dimension (LDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array A contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array A contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, A(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed.

## magma_ctrtri_expert_gpu_work()

magma_int_t magma_ctrtri_expert_gpu_work | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaFloatComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info,
|  | void * | host_work,
|  | magma_int_t * | lwork_host,
|  | void * | device_work,
|  | magma_int_t * | lwork_device,
|  | magma_queue_t | queues[2] )

CTRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm. This is an expert API, exposing more controls to the end user.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  COMPLEX array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)

  [in,out] | host_work | Workspace, allocated on host (CPU) memory. For faster CPU-GPU communication, user can allocate it as pinned memory using magma_malloc_pinned()

  [in,out]

  lwork_host

  INTEGER pointer The size of the workspace (host_work) in bytes
  - lwork_host[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_host. The workspace itself is not referenced, and no computations is performed.

- lwork[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_host.

Parameters

  [in,out] | device_work | Workspace, allocated on device (GPU) memory.

  [in,out]

  lwork_device

  INTEGER pointer The size of the workspace (device_work) in bytes
  - lwork_device[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_device. The workspace itself is not referenced, and no computation is performed.
  - lwork_device[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_device.

  [in]

  queues

  magma_queue_t array of size two
  - created/destroyed by the user outside the routine
  - Used for concurrent kernel execution, if possible

## magma_ctrtri_gpu()

magma_int_t magma_ctrtri_gpu | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaFloatComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info )

CTRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  COMPLEX array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)

## magma_dtrtri()

magma_int_t magma_dtrtri | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | double * | A,
|  | magma_int_t | lda,
|  | magma_int_t * | info )

DTRTRI computes the inverse of a real upper or lower triangular matrix A.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  A

  DOUBLE PRECISION array, dimension (LDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array A contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array A contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, A(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed.

## magma_dtrtri_expert_gpu_work()

magma_int_t magma_dtrtri_expert_gpu_work | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaDouble_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info,
|  | void * | host_work,
|  | magma_int_t * | lwork_host,
|  | void * | device_work,
|  | magma_int_t * | lwork_device,
|  | magma_queue_t | queues[2] )

DTRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm. This is an expert API, exposing more controls to the end user.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  DOUBLE PRECISION array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)

  [in,out] | host_work | Workspace, allocated on host (CPU) memory. For faster CPU-GPU communication, user can allocate it as pinned memory using magma_malloc_pinned()

  [in,out]

  lwork_host

  INTEGER pointer The size of the workspace (host_work) in bytes
  - lwork_host[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_host. The workspace itself is not referenced, and no computations is performed.

- lwork[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_host.

Parameters

  [in,out] | device_work | Workspace, allocated on device (GPU) memory.

  [in,out]

  lwork_device

  INTEGER pointer The size of the workspace (device_work) in bytes
  - lwork_device[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_device. The workspace itself is not referenced, and no computation is performed.
  - lwork_device[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_device.

  [in]

  queues

  magma_queue_t array of size two
  - created/destroyed by the user outside the routine
  - Used for concurrent kernel execution, if possible

## magma_dtrtri_gpu()

magma_int_t magma_dtrtri_gpu | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaDouble_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info )

DTRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  DOUBLE PRECISION array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)

## magma_strtri()

magma_int_t magma_strtri | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | float * | A,
|  | magma_int_t | lda,
|  | magma_int_t * | info )

STRTRI computes the inverse of a real upper or lower triangular matrix A.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  A

  REAL array, dimension (LDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array A contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array A contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, A(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed.

## magma_strtri_expert_gpu_work()

magma_int_t magma_strtri_expert_gpu_work | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaFloat_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info,
|  | void * | host_work,
|  | magma_int_t * | lwork_host,
|  | void * | device_work,
|  | magma_int_t * | lwork_device,
|  | magma_queue_t | queues[2] )

STRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm. This is an expert API, exposing more controls to the end user.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  REAL array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)

  [in,out] | host_work | Workspace, allocated on host (CPU) memory. For faster CPU-GPU communication, user can allocate it as pinned memory using magma_malloc_pinned()

  [in,out]

  lwork_host

  INTEGER pointer The size of the workspace (host_work) in bytes
  - lwork_host[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_host. The workspace itself is not referenced, and no computations is performed.

- lwork[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_host.

Parameters

  [in,out] | device_work | Workspace, allocated on device (GPU) memory.

  [in,out]

  lwork_device

  INTEGER pointer The size of the workspace (device_work) in bytes
  - lwork_device[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_device. The workspace itself is not referenced, and no computation is performed.
  - lwork_device[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_device.

  [in]

  queues

  magma_queue_t array of size two
  - created/destroyed by the user outside the routine
  - Used for concurrent kernel execution, if possible

## magma_strtri_gpu()

magma_int_t magma_strtri_gpu | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaFloat_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info )

STRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  REAL array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)

## magma_ztrtri()

magma_int_t magma_ztrtri | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magma_int_t * | info )

ZTRTRI computes the inverse of a real upper or lower triangular matrix A.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  A

  COMPLEX_16 array, dimension (LDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array A contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array A contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, A(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed.

## magma_ztrtri_expert_gpu_work()

magma_int_t magma_ztrtri_expert_gpu_work | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaDoubleComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info,
|  | void * | host_work,
|  | magma_int_t * | lwork_host,
|  | void * | device_work,
|  | magma_int_t * | lwork_device,
|  | magma_queue_t | queues[2] )

ZTRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm. This is an expert API, exposing more controls to the end user.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  COMPLEX_16 array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)

  [in,out] | host_work | Workspace, allocated on host (CPU) memory. For faster CPU-GPU communication, user can allocate it as pinned memory using magma_malloc_pinned()

  [in,out]

  lwork_host

  INTEGER pointer The size of the workspace (host_work) in bytes
  - lwork_host[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_host. The workspace itself is not referenced, and no computations is performed.

- lwork[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_host.

Parameters

  [in,out] | device_work | Workspace, allocated on device (GPU) memory.

  [in,out]

  lwork_device

  INTEGER pointer The size of the workspace (device_work) in bytes
  - lwork_device[0] < 0: a workspace query is assumed, the routine calculates the required amount of workspace and returns it in lwork_device. The workspace itself is not referenced, and no computation is performed.
  - lwork_device[0] >= 0: the routine assumes that the user has provided a workspace with the size in lwork_device.

  [in]

  queues

  magma_queue_t array of size two
  - created/destroyed by the user outside the routine
  - Used for concurrent kernel execution, if possible

## magma_ztrtri_gpu()

magma_int_t magma_ztrtri_gpu | ( | magma_uplo_t | uplo,
|  | magma_diag_t | diag,
|  | magma_int_t | n,
|  | magmaDoubleComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | info )

ZTRTRI computes the inverse of a real upper or lower triangular matrix dA.

This is the Level 3 BLAS version of the algorithm.

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: A is upper triangular;
  - = MagmaLower: A is lower triangular.

  [in]

  diag

  magma_diag_t
  - = MagmaNonUnit: A is non-unit triangular;
  - = MagmaUnit: A is unit triangular.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in,out]

  dA

  COMPLEX_16 array ON THE GPU, dimension (LDDA,N) On entry, the triangular matrix A. If UPLO = MagmaUpper, the leading N-by-N upper triangular part of the array dA contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading N-by-N lower triangular part of the array dA contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1. On exit, the (triangular) inverse of the original matrix, in the same storage format.

  [in] | ldda | INTEGER The leading dimension of the array dA. LDDA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value
  - > 0: if INFO = i, dA(i,i) is exactly zero. The triangular matrix is singular and its inverse cannot be computed. (Singularity check is currently disabled.)